/*
 * Copyright (C) 2016 Väinö Helminen
 */
#ifndef HTTP_H_27SBITO5
#define HTTP_H_27SBITO5

#include <stddef.h>
#include <sys/time.h>

#define HTTP_DATE_LENGTH 30
#define HTTP_DATE_FORMAT "%a, %d %b %Y %H:%M:%S GMT"

/**
 * Get status message text for a HTTP status code.
 */
const char* get_status_message(int status);

/**
 * Get HTTP timestamp for given or current time.
 *
 * Returns current time if timestamp is zero, empty string if
 * timestamp is -1.
 *
 * @param buf
 * @param bufsize
 * @param timestamp
 * @return buf containing a formatted timestamp or empty string
 */
const char* get_http_timestamp(char* buf, const size_t bufsize, time_t timestamp);

#endif
