/*
 * Copyright (C) 2016 Väinö Helminen
 */
#ifndef LIST_H_O7AHA8DR
#define LIST_H_O7AHA8DR

#include <stddef.h>
#include <stdbool.h>

typedef struct _List {
  void *value;
  struct _List *next;
} List;

void list_free(List **list, const bool free_values);

size_t list_length(const List *list);

List* list_tail(List *list);

void list_push(List **list, void *value);

void* list_pop(List **list);

bool list_remove(List **list, void *value);

void list_reverse(List **list);

#endif
