/*
 * Copyright (C) 2016 Väinö Helminen
 */
#ifndef PATH_H_DKT0V1UA
#define PATH_H_DKT0V1UA

#include <stddef.h>
#include <sys/time.h>

#define CWD "."

#define DIRENTRY_TYPE_UNDEFINED  (0)
#define DIRENTRY_TYPE_DIR        (1)
#define DIRENTRY_TYPE_FILE       (2)

typedef struct _DirEntry {
  short type;
  size_t size;
  time_t lastmod;
  size_t name_length;
  char name[];
} DirEntry;

DirEntry* alloc_direntry(const char *name);

size_t list_directory(const char *path, DirEntry ***entries);

void free_direntries(DirEntry ***entries);

DirEntry* resolve_path(const char *path);

#endif
