/*
 * Copyright (C) 2016 Väinö Helminen
 */
#ifndef REQUEST_H_JM30EDRU
#define REQUEST_H_JM30EDRU

#include <stddef.h>
#include <sys/time.h>
#include "inet.h"
#include "list.h"

typedef struct _Request {
  time_t timestamp;

  /* Client */
  SOCKET socket;
  char *client_addr;

  /* Request */
  char *request;
  char *method;
  char *path;
  #if 0
  char *query;
  #endif

  /* Response */
  short status;
  size_t response_size;
  List *response_headers;
} Request;

Request* alloc_request(void);

void free_request(Request **request);

int parse_request(Request *request);

void set_content_type(Request *request, const char *mime);

void set_content_length(Request *request, size_t size);

void set_last_modified(Request *request, time_t lastmod);

void add_response_header(Request *request, const char *header, const char *value);

void add_response_header_format(Request *request, const char *header, const char *format, ...);

#endif
