/*
 * Copyright (C) 2016 Väinö Helminen
 */
#ifndef STRBUF_H_5AE142B7
#define STRBUF_H_5AE142B7

#include <stddef.h>
#include <stdarg.h>

typedef struct _StringBuffer {
  size_t size;
  size_t buffer_size;
  char *buffer;
} StringBuffer;

StringBuffer* strbuf_alloc(size_t size);

void strbuf_realloc(StringBuffer *sb, size_t size);

void strbuf_free(StringBuffer **sb);

void strbuf_truncate(StringBuffer *sb, size_t size);

void strbuf_copy(StringBuffer *sb, const char *buf, const size_t size);

void strbuf_append(StringBuffer *sb, const char *str);

void strbuf_addchar(StringBuffer *sb, const int c);

void strbuf_format(StringBuffer *sb, const char *format, ...);


#endif
